## net.sf.saxon.sort
Class CollatingAtomicComparer

    java.lang.Object
      net.sf.saxon.sort.CollatingAtomicComparer

All Implemented Interfaces:
  java.io.Serializable, AtomicComparer

    public class CollatingAtomicComparer

extends java.lang.Object
implements AtomicComparer

An AtomicComparer used for comparing strings, untypedAtomic values, and URIs using a collation. A CollatingAtomicComparer is used when it is known in advance that both operands will be of these types. This enables all conversions and promotions to be bypassed: the string values of both operands are simply extracted and passed to the collator for comparison.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Constructor Summary
`CollatingAtomicComparer(StringCollator collator, Platform platform)` Create an GenericAtomicComparer

Method Summary
`int` `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`java.lang.String` `getCollationURI()` Get the collation URI
`ComparisonKey` `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`AtomicComparer` `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CollatingAtomicComparer

    public CollatingAtomicComparer(StringCollator collator,
                                   Platform platform)

  Create an GenericAtomicComparer

  Parameters:
    `collator` - the collation to be used. If the method is called at compile time, this should be a NamedCollation so that it can be cloned at run-time.
    `platform` - used to obtain collation keys.

Method Detail

### provideContext

    public AtomicComparer provideContext(XPathContext context)

  Supply the dynamic context in case this is needed for the comparison

  Specified by:
    `provideContext` in interface `AtomicComparer`
  Parameters:
    `context` - the dynamic evaluation context
  Returns:
    either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

### getCollationURI

    public java.lang.String getCollationURI()

  Get the collation URI

  Returns:
    the collation URI

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a<b, 0 if a=b, >0 if a>b
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a<b, 0 if a=b, >0 if a>b
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Copyright (c) Saxonica Limited. All rights reserved.